Index: main/waeup.kofa/trunk/src/waeup/kofa/students/reports/browser_templates/studentstatisticsreportgeneratorpage.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/reports/browser_templates/studentstatisticsreportgeneratorpage.pt	(revision 11253)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/reports/browser_templates/studentstatisticsreportgeneratorpage.pt	(revision 11254)
@@ -7,43 +7,29 @@
   </p>
   <br />
-  <div class="clearfix">
-    <label for="session" i18n:translate="">Study Modes Group:</label>
-    <div class="input">
-      <select name="mode">
-        <span tal:repeat="items view/modes" tal:omit-tag="">
-          <option
-              tal:define="name python: items[1]; title python: items[0]"
-              tal:attributes="value name">
-            <span tal:replace="title">TITLE</span>
-          </option>
-        </span>
-      </select>
-      <div class="help-inline" i18n:translate="">
-        Set study modes filter.
-      </div>
-    </div>
-    <br />
-    <label for="session">Academic Session:</label>
-    <div class="input">
-      <select name="session" i18n:translate="">
-        <span tal:repeat="items view/sessions" tal:omit-tag="">
-          <option
-              tal:define="name python: items[1]; title python: items[0]"
-              tal:attributes="value name">
-            <span tal:replace="title">TITLE</span>
-          </option>
-        </span>
-      </select>
-      <div class="help-inline" i18n:translate="">
-        Select academic session to report.
-      </div>
-    </div>
-
-  </div>
-  <div class="input">
-    <input i18n:translate="" type="submit" class="btn primary"
-           name="CREATE" value="Create" />
-    <a class="btn secondary" href=""
-       tal:attributes="href view/parent_url">Cancel</a>
-  </div>
+  <label for="session" i18n:translate="">Study Modes Group</label>
+    <select name="mode" class="form-control half">
+      <span tal:repeat="items view/modes" tal:omit-tag="">
+        <option
+            tal:define="name python: items[1]; title python: items[0]"
+            tal:attributes="value name">
+          <span tal:replace="title">TITLE</span>
+        </option>
+      </span>
+    </select>
+  <br />
+  <label for="session">Academic Session</label>
+  <select name="session" i18n:translate="" class="form-control half">
+    <span tal:repeat="items view/sessions" tal:omit-tag="">
+      <option
+          tal:define="name python: items[1]; title python: items[0]"
+          tal:attributes="value name">
+        <span tal:replace="title">TITLE</span>
+      </option>
+    </span>
+  </select>
+  <br />
+  <input i18n:translate="" type="submit" class="btn btn-primary"
+         name="CREATE" value="Create" />
+  <a class="btn btn-default" href=""
+     tal:attributes="href view/parent_url">Cancel</a>
 </form>
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/reports/level_report.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/reports/level_report.py	(revision 11253)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/reports/level_report.py	(revision 11254)
@@ -208,4 +208,5 @@
 from waeup.kofa.interfaces import academic_sessions_vocab
 from waeup.kofa.reports import get_generators
+from waeup.kofa.browser.breadcrumbs import Breadcrumb
 grok.templatedir('browser_templates')
 class LevelReportGeneratorPage(KofaPage):
@@ -291,2 +292,8 @@
             self.context.creation_dt_string)
 
+class LevelReportBreadcrumb(Breadcrumb):
+    """A breadcrumb for reports.
+    """
+    grok.context(LevelReportGenerator)
+    title = _(u'Level Report')
+    target = None
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/reports/session_results_presentation.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/reports/session_results_presentation.py	(revision 11253)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/reports/session_results_presentation.py	(revision 11254)
@@ -198,4 +198,5 @@
 from waeup.kofa.interfaces import academic_sessions_vocab
 from waeup.kofa.reports import get_generators
+from waeup.kofa.browser.breadcrumbs import Breadcrumb
 grok.templatedir('browser_templates')
 class SessionResultsPresentationGeneratorPage(LevelReportGeneratorPage):
@@ -230,2 +231,9 @@
             self.context.sessioncode, self.context.levelcode,
             self.context.creation_dt_string)
+
+class SessionResultsPresentationBreadcrumb(Breadcrumb):
+    """A breadcrumb for reports.
+    """
+    grok.context(SessionResultsPresentationGenerator)
+    title = _(u'Session Results Presentation')
+    target = None
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/reports/student_statistics.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/reports/student_statistics.py	(revision 11253)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/reports/student_statistics.py	(revision 11254)
@@ -168,4 +168,5 @@
 from waeup.kofa.interfaces import academic_sessions_vocab
 from waeup.kofa.reports import get_generators
+from waeup.kofa.browser.breadcrumbs import Breadcrumb
 grok.templatedir('browser_templates')
 class StudentStatisticsReportGeneratorPage(KofaPage):
@@ -240,2 +241,9 @@
             ob_class, self.context.__name__, filename))
         return pdf_stream
+
+class StudentStatsBreadcrumb(Breadcrumb):
+    """A breadcrumb for reports.
+    """
+    grok.context(StudentStatisticsReportGenerator)
+    title = _(u'Student Statistics')
+    target = None
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 11253)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 11254)
@@ -613,5 +613,5 @@
         # There is a correct <img> link included
         self.assertTrue(
-            '<a target="image" href="birth_certificate">'
+            'href="http://localhost/app/students/K1000000/birth_certificate"'
             in self.browser.contents)
         # Browsing the link shows a real image
@@ -673,5 +673,5 @@
             name='upload_passportuploadmanage').click()
         self.assertTrue(
-            '<img align="middle" height="125px" src="passport.jpg" />'
+            'src="http://localhost/app/students/K1000000/passport.jpg"'
             in self.browser.contents)
         # We remove the passport file again
@@ -1958,5 +1958,8 @@
         # We are logged in as student and can see the 'My Data' tab
         self.assertMatches(
-            '...<a href="#" class="dropdown-toggle">My Data</a>...',
+            '...<a href="#" class="dropdown-toggle" data-toggle="dropdown">...',
+            self.browser.contents)
+        self.assertMatches(
+            '...My Data...',
             self.browser.contents)
         self.browser.getLink("Logout").click()
@@ -2198,5 +2201,5 @@
         self.browser.getControl("Login").click()
         self.assertMatches(
-            '...<div class="alert-message warning">'
+            '...<div class="alert alert-warning">'
             'Your account has been deactivated.</div>...', self.browser.contents)
         # If suspended_comment is set this message will be flashed instead
@@ -2206,5 +2209,5 @@
         self.browser.getControl("Login").click()
         self.assertMatches(
-            '...<div class="alert-message warning">Aetsch baetsch!</div>...',
+            '...<div class="alert alert-warning">Aetsch baetsch!</div>...',
             self.browser.contents)
         self.student.suspended = False
@@ -2265,5 +2268,5 @@
             name='upload_passportuploadedit').click()
         self.assertTrue(
-            '<img align="middle" height="125px" src="passport.jpg" />'
+            'src="http://localhost/app/students/K1000000/passport.jpg"'
             in self.browser.contents)
         # Students can open admission letter
@@ -2323,5 +2326,5 @@
             name='upload_birthcertificateupload').click()
         self.assertTrue(
-            '<a target="image" href="birth_certificate">Birth Certificate Scan</a>'
+            'href="http://localhost/app/students/K1000000/birth_certificate"'
             in self.browser.contents)
         # Students can open clearance slip
@@ -2358,4 +2361,9 @@
         # Now students can add the current study level
         self.browser.getLink("Study Course").click()
+        self.student['studycourse'].current_level = None
+        self.browser.getLink("Add course list").click()
+        self.assertMatches('...Your data are incomplete...',
+                           self.browser.contents)
+        self.student['studycourse'].current_level = 100
         self.browser.getLink("Add course list").click()
         self.assertMatches('...Add current level 100 (Year 1)...',
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/viewlets.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/viewlets.py	(revision 11253)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/viewlets.py	(revision 11254)
@@ -825,5 +825,5 @@
     size = file_size(upload)
     if size > max_size:
-        view.flash(_('Uploaded file is too big.'))
+        view.flash(_('Uploaded file is too big.'), type="danger")
         return False
     upload.seek(0) # file pointer moved when determining size
@@ -831,5 +831,5 @@
     upload.seek(0) # same here
     if file_format is None:
-        view.flash(_('Could not determine file type.'))
+        view.flash(_('Could not determine file type.'), type="danger")
         return False
     basename, expected_ext = os.path.splitext(download_name)
@@ -837,5 +837,5 @@
         if '.' + file_format != expected_ext:
             view.flash(_('${a} file extension expected.',
-                mapping = {'a':expected_ext[1:]}))
+                mapping = {'a':expected_ext[1:]}), type="danger")
             return False
     else:
@@ -843,5 +843,6 @@
             view.flash(
                 _('Only the following extensions are allowed: ${a}',
-                mapping = {'a':', '.join(ALLOWED_FILE_EXTENSIONS)}))
+                mapping = {'a':', '.join(ALLOWED_FILE_EXTENSIONS)}),
+                type="danger")
             return False
         download_name += '.' + file_format
@@ -891,5 +892,5 @@
     template = default_fileupload_template
     grok.require('waeup.uploadStudentFile')
-    tab_redirect = '?tab2'
+    tab_redirect = '#tab2-top'
     mus = 1024 * 150
     upload_button =_('Upload new file')
@@ -931,5 +932,5 @@
                         self.context, self.view.__name__) + self.tab_redirect)
             else:
-                self.view.flash(_('No local file selected.'))
+                self.view.flash(_('No local file selected.'), type="danger")
                 self.view.redirect(
                     self.view.url(
@@ -959,5 +960,5 @@
     mus = 1024 * 50
     download_name = u'passport.jpg'
-    tab_redirect = '?tab2'
+    tab_redirect = '#tab2'
 
 class PassportUploadEdit(PassportUploadManage):
@@ -986,5 +987,5 @@
     mus = 1024 * 150
     download_name = u'birth_certificate'
-    tab_redirect = '?tab2'
+    tab_redirect = '#tab2-top'
 
 class Image(grok.View):
Index: main/waeup.kofa/trunk/src/waeup/kofa/widgets/phonewidget.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/widgets/phonewidget.py	(revision 11253)
+++ main/waeup.kofa/trunk/src/waeup/kofa/widgets/phonewidget.py	(revision 11254)
@@ -37,5 +37,5 @@
 
     subwidget_names = ('country', 'area', 'ext')
-    bootstrap_span = 'span2'
+    cssClass = 'phone-input'
 
     def _renderPrefixWidget(self, value):
@@ -51,7 +51,8 @@
                 '<option value="%s"%s>%s</option>' % (pval, selected, ptitle))
         options = '\n'.join(options)
-        return '<select id="%s" name="%s" size="1" class="span4">\n%s\n</select>' % (
+        return '<select id="%s" name="%s" size="1" class="%s">\n%s\n</select>' % (
             '%s.%s' % (self.name, 'country'),
             '%s.%s' % (self.name, 'country'),
+            self.cssClass,
             options)
 
@@ -83,6 +84,5 @@
             kwargs.update(name = '%s.%s' % (self.name, subname))
             kwargs.update(id=kwargs['name'])
-            # kwargs.update(cssClass = '%s %s' % (self.cssClass, 'span1'))
-            kwargs.update(cssClass = '%s %s' % ('', self.bootstrap_span))
+            kwargs.update(cssClass = '%s %s' % ('', self.cssClass))
             kwargs.update(value = subvalues[num])
             fields.append(renderElement(self.tag, **kwargs))
Index: main/waeup.kofa/trunk/src/waeup/kofa/widgets/sequencewidget.pt
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/widgets/sequencewidget.pt	(revision 11253)
+++ main/waeup.kofa/trunk/src/waeup/kofa/widgets/sequencewidget.pt	(revision 11254)
@@ -1,4 +1,3 @@
-<table border="0" class="sequencewidget"
-  i18n:domain="waeup.kofa">
+<table i18n:domain="waeup.kofa">
   <tr tal:repeat="widget view/widgets">
     <td>
@@ -19,14 +18,13 @@
       Don't forget to save the form after adding or deleting items.
       </p>
-      <input type="submit" value="Remove selected items"
-             class="btn"
+      <button type="submit"
+             class="btn btn-default"
+             tal:condition="view/need_add"
+             tal:attributes="name string:${view/name}.add"
+             tal:content="view/addButtonLabel" />
+      <button type="submit" class="btn btn-default"
              tal:condition="view/need_delete"
              tal:attributes="name string:${view/name}.remove"
-             i18n:attributes="value remove-selected-items" />
-      <input type="submit" value="Add foo"
-             class="btn"
-             tal:condition="view/need_add"
-             tal:attributes="name string:${view/name}.add;
-                             value view/addButtonLabel" />
+             i18n:translate="remove-selected-items">Remove selected items</button>
     </td>
   </tr>
